100 REM ---- BMPDITH.BAS
110 REM ---- Load a 16 color BMP and display using 4-pixel dithering.
120 REM ---- Dithering will display as 16 colors in CGA composite mode.
130 REM ---- Press c during loading or after picture is complete
140 REM ---- to toggle color burst on and off.
150 REM ---- Note: program assumes .BMP uses CGA composite palette
160 REM ---- by BdR - bas.de.reuver@home.nl
170 TOGGLE = 0
180 FILENAME$ = "-"
190 WHILE (FILENAME$ <> "")
200   CLS
210   FILES "*.BMP"
220   PRINT ""
230   PRINT "(while picture is loading, press 'c' to toggle color burst)"
240   INPUT "Enter filename to load :", FILENAME$
250   IF (FILENAME$ <> "") AND (RIGHT$(FILENAME$, 4) <> ".BMP") THEN FILENAME$ = FILENAME$ + ".BMP"
260   IF (FILENAME$ <> "") THEN GOSUB 340: REM load and display .BMP image
270   IF (FILENAME$ <> "") THEN GOSUB 770: REM wait for keypress
280 WEND
290 END: REM -- end of program
300 REM -----------------------------------
310 REM ---- load .BMP file subroutine ----
320 REM -----------------------------------
330 REM known bug: image not loaded properly when (XSIZEBMP MOD 4) <> 0
340 SCREEN 2: KEY OFF: CLS
350 B = 0
360 IPOS = 0
370 OPEN "I", 1, FILENAME$
380 REM ---- check file header ----
390 FOR I = 0 TO 117
400   B = ASC(INPUT$(1,#1))
410   IF (IPOS = 0) AND (B <> 66) THEN GOTO 940: REM no header "B"
420   IF (IPOS = 1) AND (B <> 77) THEN GOTO 940: REM no header "M"
430   IF (IPOS = 18) THEN XSIZEBMP = B
440   IF (IPOS = 19) THEN XSIZEBMP = XSIZEBMP + (B * 256)
450   IF (IPOS = 22) THEN YSIZEBMP = B
460   IF (IPOS = 23) THEN YSIZEBMP = YSIZEBMP + (B * 256)
470   IF (IPOS = 28) AND (B <> 4)  THEN GOTO 960: REM not 4 bits, 16 color
480   IPOS = IPOS + 1
490 NEXT I
500 REM ---- pixels in .BMP are stored from bottom left to top right ----
510 XPOS = 0
520 YPOS = YSIZEBMP - 1
530 WHILE (EOF(1) = 0)
540   B = ASC(INPUT$(1,#1))
550   PIXEL = INT(B/16)
560   GOSUB 670: REM draw pixel
570   PIXEL = B AND 15
580   GOSUB 670: REM draw pixel
590   WAITKEY$ = INKEY$
600   IF (WAITKEY$ = "c") THEN GOSUB 870: REM toggle while picture loading
610 WEND
620 CLOSE #1
630 RETURN
640 REM -------------------------------
650 REM ---- draw pixel subroutine ----
660 REM -------------------------------
670 IF ((PIXEL AND 1) <> 0) THEN PSET((XPOS * 4)+0, YPOS)
680 IF ((PIXEL AND 2) <> 0) THEN PSET((XPOS * 4)+1, YPOS)
690 IF ((PIXEL AND 4) <> 0) THEN PSET((XPOS * 4)+2, YPOS)
700 IF ((PIXEL AND 8) <> 0) THEN PSET((XPOS * 4)+3, YPOS)
710 XPOS = (XPOS + 1) MOD XSIZEBMP
720 IF (XPOS = 0) THEN YPOS = YPOS - 1
730 RETURN
740 REM ------------------------------------
750 REM -- wait for keypress subroutine ----
760 REM ------------------------------------
770 WAITKEY$ = ""
780 WHILE (WAITKEY$ = "")
790   WAITKEY$ = INKEY$
800   IF (WAITKEY$ = "c") THEN GOSUB 870: REM toggle after picture loaded
810   IF (WAITKEY$ = "c") THEN WAITKEY$ = ""
820 WEND
830 RETURN
840 REM -------------------------------------
850 REM ---- switch CGA modes subroutine ----
860 REM -------------------------------------
870 IF (TOGGLE = 0) THEN OUT &H3D8, &H1A: REM enable color burst 
880 IF (TOGGLE = 1) THEN OUT &H3D8, &H1E: REM disable color burst
890 TOGGLE = 1 - TOGGLE
900 RETURN
910 REM -----------------
920 REM ---- errors  ----
930 REM -----------------
940 PRINT "Not a bitmap file, error reading header, "; FILENAME$
950 END
960 PRINT "Not a 16 color bitmap file, "; FILENAME$; ", expected 4 found "; B
970 END
